import java.util.Vector;

public class MClientJoinersList
{

    MClientJoinersList()
    {
        JoinersList = null;
        JoinersList = new Vector();
    }

    public synchronized Object GetInactiveClient()
    {
        for(int i = 0; i < JoinersList.size(); i++)
            if(((MClientJoiner)JoinersList.elementAt(i)).GetState() == 2)
            {
                Object client = ((MClientJoiner)JoinersList.elementAt(i)).GetJoiner();
                JoinersList.removeElementAt(i);
                return client;
            }

        return null;
    }

    public synchronized void SetState(int ID, int state, long PID)
    {
        MClientJoiner joiner = FindJoiner(ID);
        if(joiner != null)
        {
            joiner.SetState(state);
            joiner.SetPID(PID);
        }
    }

    public synchronized boolean AddJoiner(int ID, Object joiner)
    {
        if(FindJoiner(ID) == null)
        {
            JoinersList.addElement(new MClientJoiner(ID, joiner));
            return true;
        } else
        {
            return false;
        }
    }

    private synchronized MClientJoiner FindJoiner(int ID)
    {
        for(int i = 0; i < JoinersList.size(); i++)
            if(((MClientJoiner)JoinersList.elementAt(i)).GetID() == ID)
                return (MClientJoiner)JoinersList.elementAt(i);

        return null;
    }

    public synchronized Object GetActiveClient()
    {
        for(int i = 0; i < JoinersList.size(); i++)
            if(((MClientJoiner)JoinersList.elementAt(i)).GetState() == 1)
            {
                Object client = ((MClientJoiner)JoinersList.elementAt(i)).GetJoiner();
                JoinersList.removeElementAt(i);
                return client;
            }

        return null;
    }

    public synchronized boolean IsListEmpty()
    {
        return JoinersList.size() == 0;
    }

    Vector JoinersList;
}
