public class GameTypes
{

    public GameTypes()
    {
    }

    static boolean IsTheSameGame(int GameType1, int GameType2)
    {
        return GameType1 == GameType2;
    }

    public static String GetGameName(int GameType)
    {
        String type = "unkwnown";
        switch(GameType)
        {
        case 65536: 
            type = "Chrome";
            break;

        case 65537: 
            type = "Chrome Demo";
            break;

        case 131072: 
            type = "Expand Rally";
            break;

        case 131073: 
            type = "Expand Rally Demo";
            break;

        case 196608: 
            type = "Chess 3000";
            break;

        case 196609: 
            type = "Chess 3000 Demo";
            break;
        }
        return type;
    }

    static boolean IsDemo(int GameType)
    {
        return (GameType & 1) == 1;
    }

    static final int GAME_CHROME = 0x10000;
    static final int GAME_CHROME_DEMO = 0x10001;
    static final int GAME_EXPAND_RALLY = 0x20000;
    static final int GAME_EXPAND_RALLY_DEMO = 0x20001;
    static final int GAME_CHESS_3000 = 0x30000;
    static final int GAME_CHESS_3000_DEMO = 0x30001;
    static final int GameTypeList[] = {
        0x10000, 0x10001, 0x20000, 0x20001, 0x30000, 0x30001
    };

}
