import java.util.Vector;

public class MClientGameServers
{

    public boolean EndOfList()
    {
        if(20000L < System.currentTimeMillis() - RequestTime && EndOfListNumber > 0)
            EndOfListNumber = AskNumber;
        return EndOfListNumber == 0 && AskNumber == 0 || EndOfListNumber > 0 && AskNumber >= EndOfListNumber;
    }

    public synchronized int GetServerPortCom(int ServerNr)
    {
        return ((MClientGameServer)GameServers.elementAt(ServerNr)).GetPortCom();
    }

    MClientGameServers(MasterClient mc)
    {
        GameServers = new Vector();
        this.mc = mc;
    }

    public synchronized void SetAskNumber(int number)
    {
        AskNumber = number;
    }

    public synchronized int GetServerPortGame(int ServerNr)
    {
        return ((MClientGameServer)GameServers.elementAt(ServerNr)).GetPortGame();
    }

    public synchronized void ClearServersList()
    {
        RequestTime = System.currentTimeMillis();
        GameServers.removeAllElements();
        EndOfListNumber = 0;
        AskNumber = 0;
    }

    public synchronized int GetServerAddress(int ServerNr)
    {
        return ((MClientGameServer)GameServers.elementAt(ServerNr)).GetAddress();
    }

    public synchronized int GetServersNr()
    {
        return GameServers.size();
    }

    public synchronized void AddGameServers(MClientMessageReader Message)
    {
        int nr = Message.Data_S_GS_LIST.GetServersNr();
        for(int i = 0; i < nr; i++)
        {
            MClientGameServer gs = Message.Data_S_GS_LIST.GetServer();
            if(gs != null && GameServers.indexOf(gs) == -1)
                GameServers.addElement(gs);
        }

        if(Message.Data_S_GS_LIST.EndOfList())
            EndOfListNumber++;
    }

    public synchronized String GetServerInfo(int ServerNr)
    {
        return ((MClientGameServer)GameServers.elementAt(ServerNr)).GetInfo();
    }

    private MasterClient mc;
    private Vector GameServers;
    private int AskNumber;
    private int EndOfListNumber;
    private long RequestTime;
}
