import java.net.InetAddress;
import java.net.UnknownHostException;

public class MClientMessageComposer extends MessageComposer
{

    public DataComposer_C_SEARCHING_GS Get_SEARCHING_GS_Data()
    {
        return (DataComposer_C_SEARCHING_GS)DataObject;
    }

    public DataComposer_C_NEW_GAME Get_NEW_GAME_Data()
    {
        return (DataComposer_C_NEW_GAME)DataObject;
    }

    public DataComposer_C_IS_CLIENT_ACTIVE Get_IS_CLIENT_ACTIVE_Data()
    {
        return (DataComposer_C_IS_CLIENT_ACTIVE)DataObject;
    }

    public MClientMessageComposer(int VersionNr, int StatementNr, InetAddress Address, int PortNr)
    {
        super(VersionNr, StatementNr, Address, PortNr);
    }

    public MClientMessageComposer(int VersionNr, int StatementNr, InetAddress Address, int PortNr, int ID)
    {
        super(VersionNr, StatementNr, Address, PortNr);
        ((DataComposer_ID)DataObject).SetData(ID);
    }

    public MClientMessageComposer(int VersionNr, int StatementNr, String Address, int PortNr)
        throws UnknownHostException
    {
        super(VersionNr, StatementNr, Address, PortNr);
    }

    public MClientMessageComposer(int VersionNr, int StatementNr, String Address, int PortNr, int ID)
        throws UnknownHostException
    {
        super(VersionNr, StatementNr, Address, PortNr);
        ((DataComposer_ID)DataObject).SetData(ID);
    }

    protected void Method_C_AUTHORIZE_ME()
    {
        DataObject = new DataComposer_ID(this);
    }

    public DataComposer_C_FREE_ASK Get_ASK_Data()
    {
        return (DataComposer_C_FREE_ASK)DataObject;
    }

    protected void Method_C_CDKEY()
    {
        DataObject = new DataComposer_C_CDKEY(this);
    }

    public DataComposer_C_CDKEY Get_CDKEY_Data()
    {
        return (DataComposer_C_CDKEY)DataObject;
    }

    protected void Method_C_IM_ACTIVE()
    {
        DataObject = new DataComposer_ID(this);
    }

    protected void Method_C_SEARCHING_GS()
    {
        DataObject = new DataComposer_C_SEARCHING_GS(this);
    }

    protected void Method_C_MI_ACTIVE()
    {
        DataObject = new DataComposer_ID(this);
    }

    protected void Method_C_NEW_GAME()
    {
        DataObject = new DataComposer_C_NEW_GAME(this);
    }

    protected void Method_C_JOIN_GAME()
    {
        DataObject = new DataComposer_ID(this);
    }

    protected void Method_C_BYE()
    {
        DataObject = new DataComposer_ID(this);
    }

    public DataComposer_ID Get_ID_Data()
    {
        return (DataComposer_ID)DataObject;
    }

    protected void Method_C_FREE_ASK()
    {
        DataObject = new DataComposer_C_FREE_ASK(this);
    }

    protected void Method_C_IS_CLIENT_ACTIVE()
    {
        DataObject = new DataComposer_C_IS_CLIENT_ACTIVE(this);
    }

    protected void Method_C_CLOSE_GAME()
    {
        DataObject = new DataComposer_ID(this);
    }

    protected void Method_C_QUIT_GAME()
    {
        DataObject = new DataComposer_ID(this);
    }

    private Object DataObject;
}
